%global debug_package %{nil}

Summary:       ANother Tool for Language Recognition
Name:          antlr
Version:       2.7.7
Release:       2%{?dist}
License:       ANTLR-PD
URL:           http://www.antlr2.org/

Source0:       https://www.antlr2.org/download/%{name}-%{version}.tar.gz
Source1:       %{name}-build.xml
Source2:       %{name}-script
Source3:       https://repo1.maven.org/maven2/%{name}/%{name}/%{version}/%{name}-%{version}.pom
Patch3000:     %{name}-%{version}-newgcc.patch

BuildRequires: gcc-c++ make ant java-devel javapackages-local

%description
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%package     tool
Summary:       ANother Tool for Language Recognition
Provides:      %{name} = %{version}-%{release}
Requires:      javapackages-tools
BuildArch:     noarch

%description tool
ANTLR, ANother Tool for Language Recognition, (formerly PCCTS) is a
language tool that provides a framework for constructing recognizers,
compilers, and translators from grammatical descriptions containing
C++ or Java actions [You can use PCCTS 1.xx to generate C-based
parsers].

%package     manual
Summary:       Manual for %{name}
BuildArch:     noarch

%description manual
Documentation for %{name}.

%package     javadoc
Summary:       Javadoc for %{name}
BuildArch:     noarch

%description javadoc
Javadoc for %{name}.

%package     C++
Summary:       C++ bindings for antlr2 generated parsers
Provides:      antlr-static = %{version}-%{release}

%description C++
This package provides a static C++ library for parsers generated by ANTLR2.

%prep
%autosetup -N
find . -name "*.jar" -exec rm -f {} \;
cp -p %{SOURCE1} build.xml
%patch3000
sed -i 's/\r//' LICENSE.txt

%mvn_file %{name}:%{name} %{name}

%build
ant -Dj2se.apidoc=%{_javadocdir}/java
cp work/lib/antlr.jar .
export CLASSPATH=.
%configure --without-examples
make CXXFLAGS="${CXXFLAGS} -fPIC" DEBUG=1 verbose=1
rm antlr.jar

rm doc/{Makefile,Makefile.in}
chmod 0644 doc/*

%install
%mvn_artifact %{SOURCE3} work/lib/%{name}.jar
%mvn_alias %{name}:%{name} %{name}:%{name}all
%mvn_install -J work/api

mkdir -p $RPM_BUILD_ROOT{%{_includedir}/%{name},%{_libdir},%{_bindir}}
install -p -m 755 %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/antlr

install -p -m 644 lib/cpp/antlr/*.hpp $RPM_BUILD_ROOT%{_includedir}/%{name}
install -p -m 644 lib/cpp/src/libantlr.a $RPM_BUILD_ROOT%{_libdir}
install -p -m 755 scripts/antlr-config $RPM_BUILD_ROOT%{_bindir}

%files tool -f .mfiles
%license LICENSE.txt
%{_bindir}/antlr

%files C++
%license LICENSE.txt
%{_includedir}/%{name}
%{_libdir}/libantlr.a
%{_bindir}/antlr-config

%files manual
%license LICENSE.txt
%doc doc/*

%files javadoc -f .mfiles-javadoc
%license LICENSE.txt

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.7.7-2
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Apr 21 2023 Xiaojie Chen <jackxjchen@tencent.com> - 2.7.7-1
- Initial build
